import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CognitoUserPoolClientConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#access_token_validity CognitoUserPoolClient#access_token_validity}.
     *
     * @stability stable
     */
    readonly accessTokenValidity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#allowed_oauth_flows CognitoUserPoolClient#allowed_oauth_flows}.
     *
     * @stability stable
     */
    readonly allowedOauthFlows?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#allowed_oauth_flows_user_pool_client CognitoUserPoolClient#allowed_oauth_flows_user_pool_client}.
     *
     * @stability stable
     */
    readonly allowedOauthFlowsUserPoolClient?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#allowed_oauth_scopes CognitoUserPoolClient#allowed_oauth_scopes}.
     *
     * @stability stable
     */
    readonly allowedOauthScopes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#callback_urls CognitoUserPoolClient#callback_urls}.
     *
     * @stability stable
     */
    readonly callbackUrls?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#default_redirect_uri CognitoUserPoolClient#default_redirect_uri}.
     *
     * @stability stable
     */
    readonly defaultRedirectUri?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#explicit_auth_flows CognitoUserPoolClient#explicit_auth_flows}.
     *
     * @stability stable
     */
    readonly explicitAuthFlows?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#generate_secret CognitoUserPoolClient#generate_secret}.
     *
     * @stability stable
     */
    readonly generateSecret?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#id_token_validity CognitoUserPoolClient#id_token_validity}.
     *
     * @stability stable
     */
    readonly idTokenValidity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#logout_urls CognitoUserPoolClient#logout_urls}.
     *
     * @stability stable
     */
    readonly logoutUrls?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#name CognitoUserPoolClient#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#prevent_user_existence_errors CognitoUserPoolClient#prevent_user_existence_errors}.
     *
     * @stability stable
     */
    readonly preventUserExistenceErrors?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#read_attributes CognitoUserPoolClient#read_attributes}.
     *
     * @stability stable
     */
    readonly readAttributes?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#refresh_token_validity CognitoUserPoolClient#refresh_token_validity}.
     *
     * @stability stable
     */
    readonly refreshTokenValidity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#supported_identity_providers CognitoUserPoolClient#supported_identity_providers}.
     *
     * @stability stable
     */
    readonly supportedIdentityProviders?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#user_pool_id CognitoUserPoolClient#user_pool_id}.
     *
     * @stability stable
     */
    readonly userPoolId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#write_attributes CognitoUserPoolClient#write_attributes}.
     *
     * @stability stable
     */
    readonly writeAttributes?: string[];
    /**
     * analytics_configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#analytics_configuration CognitoUserPoolClient#analytics_configuration}
     *
     * @stability stable
     */
    readonly analyticsConfiguration?: CognitoUserPoolClientAnalyticsConfiguration[];
    /**
     * token_validity_units block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#token_validity_units CognitoUserPoolClient#token_validity_units}
     *
     * @stability stable
     */
    readonly tokenValidityUnits?: CognitoUserPoolClientTokenValidityUnits[];
}
/**
 * @stability stable
 */
export interface CognitoUserPoolClientAnalyticsConfiguration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#application_arn CognitoUserPoolClient#application_arn}.
     *
     * @stability stable
     */
    readonly applicationArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#application_id CognitoUserPoolClient#application_id}.
     *
     * @stability stable
     */
    readonly applicationId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#external_id CognitoUserPoolClient#external_id}.
     *
     * @stability stable
     */
    readonly externalId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#role_arn CognitoUserPoolClient#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#user_data_shared CognitoUserPoolClient#user_data_shared}.
     *
     * @stability stable
     */
    readonly userDataShared?: boolean;
}
/**
 * @stability stable
 */
export interface CognitoUserPoolClientTokenValidityUnits {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#access_token CognitoUserPoolClient#access_token}.
     *
     * @stability stable
     */
    readonly accessToken?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#id_token CognitoUserPoolClient#id_token}.
     *
     * @stability stable
     */
    readonly idToken?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html#refresh_token CognitoUserPoolClient#refresh_token}.
     *
     * @stability stable
     */
    readonly refreshToken?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html aws_cognito_user_pool_client}.
 *
 * @stability stable
 */
export declare class CognitoUserPoolClient extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cognito_user_pool_client.html aws_cognito_user_pool_client} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CognitoUserPoolClientConfig);
    private _accessTokenValidity?;
    /**
     * @stability stable
     */
    get accessTokenValidity(): number;
    /**
     * @stability stable
     */
    set accessTokenValidity(value: number);
    /**
     * @stability stable
     */
    resetAccessTokenValidity(): void;
    /**
     * @stability stable
     */
    get accessTokenValidityInput(): number | undefined;
    private _allowedOauthFlows?;
    /**
     * @stability stable
     */
    get allowedOauthFlows(): string[];
    /**
     * @stability stable
     */
    set allowedOauthFlows(value: string[]);
    /**
     * @stability stable
     */
    resetAllowedOauthFlows(): void;
    /**
     * @stability stable
     */
    get allowedOauthFlowsInput(): string[] | undefined;
    private _allowedOauthFlowsUserPoolClient?;
    /**
     * @stability stable
     */
    get allowedOauthFlowsUserPoolClient(): boolean;
    /**
     * @stability stable
     */
    set allowedOauthFlowsUserPoolClient(value: boolean);
    /**
     * @stability stable
     */
    resetAllowedOauthFlowsUserPoolClient(): void;
    /**
     * @stability stable
     */
    get allowedOauthFlowsUserPoolClientInput(): boolean | undefined;
    private _allowedOauthScopes?;
    /**
     * @stability stable
     */
    get allowedOauthScopes(): string[];
    /**
     * @stability stable
     */
    set allowedOauthScopes(value: string[]);
    /**
     * @stability stable
     */
    resetAllowedOauthScopes(): void;
    /**
     * @stability stable
     */
    get allowedOauthScopesInput(): string[] | undefined;
    private _callbackUrls?;
    /**
     * @stability stable
     */
    get callbackUrls(): string[];
    /**
     * @stability stable
     */
    set callbackUrls(value: string[]);
    /**
     * @stability stable
     */
    resetCallbackUrls(): void;
    /**
     * @stability stable
     */
    get callbackUrlsInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get clientSecret(): string;
    private _defaultRedirectUri?;
    /**
     * @stability stable
     */
    get defaultRedirectUri(): string;
    /**
     * @stability stable
     */
    set defaultRedirectUri(value: string);
    /**
     * @stability stable
     */
    resetDefaultRedirectUri(): void;
    /**
     * @stability stable
     */
    get defaultRedirectUriInput(): string | undefined;
    private _explicitAuthFlows?;
    /**
     * @stability stable
     */
    get explicitAuthFlows(): string[];
    /**
     * @stability stable
     */
    set explicitAuthFlows(value: string[]);
    /**
     * @stability stable
     */
    resetExplicitAuthFlows(): void;
    /**
     * @stability stable
     */
    get explicitAuthFlowsInput(): string[] | undefined;
    private _generateSecret?;
    /**
     * @stability stable
     */
    get generateSecret(): boolean;
    /**
     * @stability stable
     */
    set generateSecret(value: boolean);
    /**
     * @stability stable
     */
    resetGenerateSecret(): void;
    /**
     * @stability stable
     */
    get generateSecretInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _idTokenValidity?;
    /**
     * @stability stable
     */
    get idTokenValidity(): number;
    /**
     * @stability stable
     */
    set idTokenValidity(value: number);
    /**
     * @stability stable
     */
    resetIdTokenValidity(): void;
    /**
     * @stability stable
     */
    get idTokenValidityInput(): number | undefined;
    private _logoutUrls?;
    /**
     * @stability stable
     */
    get logoutUrls(): string[];
    /**
     * @stability stable
     */
    set logoutUrls(value: string[]);
    /**
     * @stability stable
     */
    resetLogoutUrls(): void;
    /**
     * @stability stable
     */
    get logoutUrlsInput(): string[] | undefined;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _preventUserExistenceErrors?;
    /**
     * @stability stable
     */
    get preventUserExistenceErrors(): string;
    /**
     * @stability stable
     */
    set preventUserExistenceErrors(value: string);
    /**
     * @stability stable
     */
    resetPreventUserExistenceErrors(): void;
    /**
     * @stability stable
     */
    get preventUserExistenceErrorsInput(): string | undefined;
    private _readAttributes?;
    /**
     * @stability stable
     */
    get readAttributes(): string[];
    /**
     * @stability stable
     */
    set readAttributes(value: string[]);
    /**
     * @stability stable
     */
    resetReadAttributes(): void;
    /**
     * @stability stable
     */
    get readAttributesInput(): string[] | undefined;
    private _refreshTokenValidity?;
    /**
     * @stability stable
     */
    get refreshTokenValidity(): number;
    /**
     * @stability stable
     */
    set refreshTokenValidity(value: number);
    /**
     * @stability stable
     */
    resetRefreshTokenValidity(): void;
    /**
     * @stability stable
     */
    get refreshTokenValidityInput(): number | undefined;
    private _supportedIdentityProviders?;
    /**
     * @stability stable
     */
    get supportedIdentityProviders(): string[];
    /**
     * @stability stable
     */
    set supportedIdentityProviders(value: string[]);
    /**
     * @stability stable
     */
    resetSupportedIdentityProviders(): void;
    /**
     * @stability stable
     */
    get supportedIdentityProvidersInput(): string[] | undefined;
    private _userPoolId;
    /**
     * @stability stable
     */
    get userPoolId(): string;
    /**
     * @stability stable
     */
    set userPoolId(value: string);
    /**
     * @stability stable
     */
    get userPoolIdInput(): string;
    private _writeAttributes?;
    /**
     * @stability stable
     */
    get writeAttributes(): string[];
    /**
     * @stability stable
     */
    set writeAttributes(value: string[]);
    /**
     * @stability stable
     */
    resetWriteAttributes(): void;
    /**
     * @stability stable
     */
    get writeAttributesInput(): string[] | undefined;
    private _analyticsConfiguration?;
    /**
     * @stability stable
     */
    get analyticsConfiguration(): CognitoUserPoolClientAnalyticsConfiguration[];
    /**
     * @stability stable
     */
    set analyticsConfiguration(value: CognitoUserPoolClientAnalyticsConfiguration[]);
    /**
     * @stability stable
     */
    resetAnalyticsConfiguration(): void;
    /**
     * @stability stable
     */
    get analyticsConfigurationInput(): CognitoUserPoolClientAnalyticsConfiguration[] | undefined;
    private _tokenValidityUnits?;
    /**
     * @stability stable
     */
    get tokenValidityUnits(): CognitoUserPoolClientTokenValidityUnits[];
    /**
     * @stability stable
     */
    set tokenValidityUnits(value: CognitoUserPoolClientTokenValidityUnits[]);
    /**
     * @stability stable
     */
    resetTokenValidityUnits(): void;
    /**
     * @stability stable
     */
    get tokenValidityUnitsInput(): CognitoUserPoolClientTokenValidityUnits[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
