import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsKmsSecretsConfig extends cdktf.TerraformMetaArguments {
    /**
     * secret block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/kms_secrets.html#secret DataAwsKmsSecrets#secret}
     *
     * @stability stable
     */
    readonly secret: DataAwsKmsSecretsSecret[];
}
/**
 * @stability stable
 */
export interface DataAwsKmsSecretsSecret {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/kms_secrets.html#context DataAwsKmsSecrets#context}.
     *
     * @stability stable
     */
    readonly context?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/kms_secrets.html#grant_tokens DataAwsKmsSecrets#grant_tokens}.
     *
     * @stability stable
     */
    readonly grantTokens?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/kms_secrets.html#name DataAwsKmsSecrets#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/kms_secrets.html#payload DataAwsKmsSecrets#payload}.
     *
     * @stability stable
     */
    readonly payload: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/kms_secrets.html aws_kms_secrets}.
 *
 * @stability stable
 */
export declare class DataAwsKmsSecrets extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/kms_secrets.html aws_kms_secrets} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsKmsSecretsConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    plaintext(key: string): string;
    private _secret;
    /**
     * @stability stable
     */
    get secret(): DataAwsKmsSecretsSecret[];
    /**
     * @stability stable
     */
    set secret(value: DataAwsKmsSecretsSecret[]);
    /**
     * @stability stable
     */
    get secretInput(): DataAwsKmsSecretsSecret[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
