import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Ec2FleetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#excess_capacity_termination_policy Ec2Fleet#excess_capacity_termination_policy}.
     *
     * @stability stable
     */
    readonly excessCapacityTerminationPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#replace_unhealthy_instances Ec2Fleet#replace_unhealthy_instances}.
     *
     * @stability stable
     */
    readonly replaceUnhealthyInstances?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#tags Ec2Fleet#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#tags_all Ec2Fleet#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#terminate_instances Ec2Fleet#terminate_instances}.
     *
     * @stability stable
     */
    readonly terminateInstances?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#terminate_instances_with_expiration Ec2Fleet#terminate_instances_with_expiration}.
     *
     * @stability stable
     */
    readonly terminateInstancesWithExpiration?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#type Ec2Fleet#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * launch_template_config block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#launch_template_config Ec2Fleet#launch_template_config}
     *
     * @stability stable
     */
    readonly launchTemplateConfig: Ec2FleetLaunchTemplateConfig[];
    /**
     * on_demand_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#on_demand_options Ec2Fleet#on_demand_options}
     *
     * @stability stable
     */
    readonly onDemandOptions?: Ec2FleetOnDemandOptions[];
    /**
     * spot_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#spot_options Ec2Fleet#spot_options}
     *
     * @stability stable
     */
    readonly spotOptions?: Ec2FleetSpotOptions[];
    /**
     * target_capacity_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#target_capacity_specification Ec2Fleet#target_capacity_specification}
     *
     * @stability stable
     */
    readonly targetCapacitySpecification: Ec2FleetTargetCapacitySpecification[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#timeouts Ec2Fleet#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: Ec2FleetTimeouts;
}
/**
 * @stability stable
 */
export interface Ec2FleetLaunchTemplateConfigLaunchTemplateSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#launch_template_id Ec2Fleet#launch_template_id}.
     *
     * @stability stable
     */
    readonly launchTemplateId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#launch_template_name Ec2Fleet#launch_template_name}.
     *
     * @stability stable
     */
    readonly launchTemplateName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#version Ec2Fleet#version}.
     *
     * @stability stable
     */
    readonly version: string;
}
/**
 * @stability stable
 */
export interface Ec2FleetLaunchTemplateConfigOverride {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#availability_zone Ec2Fleet#availability_zone}.
     *
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#instance_type Ec2Fleet#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#max_price Ec2Fleet#max_price}.
     *
     * @stability stable
     */
    readonly maxPrice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#priority Ec2Fleet#priority}.
     *
     * @stability stable
     */
    readonly priority?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#subnet_id Ec2Fleet#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#weighted_capacity Ec2Fleet#weighted_capacity}.
     *
     * @stability stable
     */
    readonly weightedCapacity?: number;
}
/**
 * @stability stable
 */
export interface Ec2FleetLaunchTemplateConfig {
    /**
     * launch_template_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#launch_template_specification Ec2Fleet#launch_template_specification}
     *
     * @stability stable
     */
    readonly launchTemplateSpecification: Ec2FleetLaunchTemplateConfigLaunchTemplateSpecification[];
    /**
     * override block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#override Ec2Fleet#override}
     *
     * @stability stable
     */
    readonly override?: Ec2FleetLaunchTemplateConfigOverride[];
}
/**
 * @stability stable
 */
export interface Ec2FleetOnDemandOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#allocation_strategy Ec2Fleet#allocation_strategy}.
     *
     * @stability stable
     */
    readonly allocationStrategy?: string;
}
/**
 * @stability stable
 */
export interface Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalance {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#replacement_strategy Ec2Fleet#replacement_strategy}.
     *
     * @stability stable
     */
    readonly replacementStrategy?: string;
}
/**
 * @stability stable
 */
export interface Ec2FleetSpotOptionsMaintenanceStrategies {
    /**
     * capacity_rebalance block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#capacity_rebalance Ec2Fleet#capacity_rebalance}
     *
     * @stability stable
     */
    readonly capacityRebalance?: Ec2FleetSpotOptionsMaintenanceStrategiesCapacityRebalance[];
}
/**
 * @stability stable
 */
export interface Ec2FleetSpotOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#allocation_strategy Ec2Fleet#allocation_strategy}.
     *
     * @stability stable
     */
    readonly allocationStrategy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#instance_interruption_behavior Ec2Fleet#instance_interruption_behavior}.
     *
     * @stability stable
     */
    readonly instanceInterruptionBehavior?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#instance_pools_to_use_count Ec2Fleet#instance_pools_to_use_count}.
     *
     * @stability stable
     */
    readonly instancePoolsToUseCount?: number;
    /**
     * maintenance_strategies block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#maintenance_strategies Ec2Fleet#maintenance_strategies}
     *
     * @stability stable
     */
    readonly maintenanceStrategies?: Ec2FleetSpotOptionsMaintenanceStrategies[];
}
/**
 * @stability stable
 */
export interface Ec2FleetTargetCapacitySpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#default_target_capacity_type Ec2Fleet#default_target_capacity_type}.
     *
     * @stability stable
     */
    readonly defaultTargetCapacityType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#on_demand_target_capacity Ec2Fleet#on_demand_target_capacity}.
     *
     * @stability stable
     */
    readonly onDemandTargetCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#spot_target_capacity Ec2Fleet#spot_target_capacity}.
     *
     * @stability stable
     */
    readonly spotTargetCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#total_target_capacity Ec2Fleet#total_target_capacity}.
     *
     * @stability stable
     */
    readonly totalTargetCapacity: number;
}
/**
 * @stability stable
 */
export interface Ec2FleetTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#create Ec2Fleet#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#delete Ec2Fleet#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html#update Ec2Fleet#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html aws_ec2_fleet}.
 *
 * @stability stable
 */
export declare class Ec2Fleet extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/ec2_fleet.html aws_ec2_fleet} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Ec2FleetConfig);
    private _excessCapacityTerminationPolicy?;
    /**
     * @stability stable
     */
    get excessCapacityTerminationPolicy(): string;
    /**
     * @stability stable
     */
    set excessCapacityTerminationPolicy(value: string);
    /**
     * @stability stable
     */
    resetExcessCapacityTerminationPolicy(): void;
    /**
     * @stability stable
     */
    get excessCapacityTerminationPolicyInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _replaceUnhealthyInstances?;
    /**
     * @stability stable
     */
    get replaceUnhealthyInstances(): boolean;
    /**
     * @stability stable
     */
    set replaceUnhealthyInstances(value: boolean);
    /**
     * @stability stable
     */
    resetReplaceUnhealthyInstances(): void;
    /**
     * @stability stable
     */
    get replaceUnhealthyInstancesInput(): boolean | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _terminateInstances?;
    /**
     * @stability stable
     */
    get terminateInstances(): boolean;
    /**
     * @stability stable
     */
    set terminateInstances(value: boolean);
    /**
     * @stability stable
     */
    resetTerminateInstances(): void;
    /**
     * @stability stable
     */
    get terminateInstancesInput(): boolean | undefined;
    private _terminateInstancesWithExpiration?;
    /**
     * @stability stable
     */
    get terminateInstancesWithExpiration(): boolean;
    /**
     * @stability stable
     */
    set terminateInstancesWithExpiration(value: boolean);
    /**
     * @stability stable
     */
    resetTerminateInstancesWithExpiration(): void;
    /**
     * @stability stable
     */
    get terminateInstancesWithExpirationInput(): boolean | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _launchTemplateConfig;
    /**
     * @stability stable
     */
    get launchTemplateConfig(): Ec2FleetLaunchTemplateConfig[];
    /**
     * @stability stable
     */
    set launchTemplateConfig(value: Ec2FleetLaunchTemplateConfig[]);
    /**
     * @stability stable
     */
    get launchTemplateConfigInput(): Ec2FleetLaunchTemplateConfig[];
    private _onDemandOptions?;
    /**
     * @stability stable
     */
    get onDemandOptions(): Ec2FleetOnDemandOptions[];
    /**
     * @stability stable
     */
    set onDemandOptions(value: Ec2FleetOnDemandOptions[]);
    /**
     * @stability stable
     */
    resetOnDemandOptions(): void;
    /**
     * @stability stable
     */
    get onDemandOptionsInput(): Ec2FleetOnDemandOptions[] | undefined;
    private _spotOptions?;
    /**
     * @stability stable
     */
    get spotOptions(): Ec2FleetSpotOptions[];
    /**
     * @stability stable
     */
    set spotOptions(value: Ec2FleetSpotOptions[]);
    /**
     * @stability stable
     */
    resetSpotOptions(): void;
    /**
     * @stability stable
     */
    get spotOptionsInput(): Ec2FleetSpotOptions[] | undefined;
    private _targetCapacitySpecification;
    /**
     * @stability stable
     */
    get targetCapacitySpecification(): Ec2FleetTargetCapacitySpecification[];
    /**
     * @stability stable
     */
    set targetCapacitySpecification(value: Ec2FleetTargetCapacitySpecification[]);
    /**
     * @stability stable
     */
    get targetCapacitySpecificationInput(): Ec2FleetTargetCapacitySpecification[];
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): Ec2FleetTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: Ec2FleetTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): Ec2FleetTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
