import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ElastictranscoderPresetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#container ElastictranscoderPreset#container}.
     *
     * @stability stable
     */
    readonly container: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#description ElastictranscoderPreset#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#name ElastictranscoderPreset#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#type ElastictranscoderPreset#type}.
     *
     * @stability stable
     */
    readonly type?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#video_codec_options ElastictranscoderPreset#video_codec_options}.
     *
     * @stability stable
     */
    readonly videoCodecOptions?: {
        [key: string]: string;
    };
    /**
     * audio block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#audio ElastictranscoderPreset#audio}
     *
     * @stability stable
     */
    readonly audio?: ElastictranscoderPresetAudio[];
    /**
     * audio_codec_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#audio_codec_options ElastictranscoderPreset#audio_codec_options}
     *
     * @stability stable
     */
    readonly audioCodecOptions?: ElastictranscoderPresetAudioCodecOptions[];
    /**
     * thumbnails block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#thumbnails ElastictranscoderPreset#thumbnails}
     *
     * @stability stable
     */
    readonly thumbnails?: ElastictranscoderPresetThumbnails[];
    /**
     * video block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#video ElastictranscoderPreset#video}
     *
     * @stability stable
     */
    readonly video?: ElastictranscoderPresetVideo[];
    /**
     * video_watermarks block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#video_watermarks ElastictranscoderPreset#video_watermarks}
     *
     * @stability stable
     */
    readonly videoWatermarks?: ElastictranscoderPresetVideoWatermarks[];
}
/**
 * @stability stable
 */
export interface ElastictranscoderPresetAudio {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#audio_packing_mode ElastictranscoderPreset#audio_packing_mode}.
     *
     * @stability stable
     */
    readonly audioPackingMode?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#bit_rate ElastictranscoderPreset#bit_rate}.
     *
     * @stability stable
     */
    readonly bitRate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#channels ElastictranscoderPreset#channels}.
     *
     * @stability stable
     */
    readonly channels?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#codec ElastictranscoderPreset#codec}.
     *
     * @stability stable
     */
    readonly codec?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#sample_rate ElastictranscoderPreset#sample_rate}.
     *
     * @stability stable
     */
    readonly sampleRate?: string;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPresetAudioCodecOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#bit_depth ElastictranscoderPreset#bit_depth}.
     *
     * @stability stable
     */
    readonly bitDepth?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#bit_order ElastictranscoderPreset#bit_order}.
     *
     * @stability stable
     */
    readonly bitOrder?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#profile ElastictranscoderPreset#profile}.
     *
     * @stability stable
     */
    readonly profile?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#signed ElastictranscoderPreset#signed}.
     *
     * @stability stable
     */
    readonly signed?: string;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPresetThumbnails {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#aspect_ratio ElastictranscoderPreset#aspect_ratio}.
     *
     * @stability stable
     */
    readonly aspectRatio?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#format ElastictranscoderPreset#format}.
     *
     * @stability stable
     */
    readonly format?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#interval ElastictranscoderPreset#interval}.
     *
     * @stability stable
     */
    readonly interval?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#max_height ElastictranscoderPreset#max_height}.
     *
     * @stability stable
     */
    readonly maxHeight?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#max_width ElastictranscoderPreset#max_width}.
     *
     * @stability stable
     */
    readonly maxWidth?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#padding_policy ElastictranscoderPreset#padding_policy}.
     *
     * @stability stable
     */
    readonly paddingPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#resolution ElastictranscoderPreset#resolution}.
     *
     * @stability stable
     */
    readonly resolution?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#sizing_policy ElastictranscoderPreset#sizing_policy}.
     *
     * @stability stable
     */
    readonly sizingPolicy?: string;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPresetVideo {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#aspect_ratio ElastictranscoderPreset#aspect_ratio}.
     *
     * @stability stable
     */
    readonly aspectRatio?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#bit_rate ElastictranscoderPreset#bit_rate}.
     *
     * @stability stable
     */
    readonly bitRate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#codec ElastictranscoderPreset#codec}.
     *
     * @stability stable
     */
    readonly codec?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#display_aspect_ratio ElastictranscoderPreset#display_aspect_ratio}.
     *
     * @stability stable
     */
    readonly displayAspectRatio?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#fixed_gop ElastictranscoderPreset#fixed_gop}.
     *
     * @stability stable
     */
    readonly fixedGop?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#frame_rate ElastictranscoderPreset#frame_rate}.
     *
     * @stability stable
     */
    readonly frameRate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#keyframes_max_dist ElastictranscoderPreset#keyframes_max_dist}.
     *
     * @stability stable
     */
    readonly keyframesMaxDist?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#max_frame_rate ElastictranscoderPreset#max_frame_rate}.
     *
     * @stability stable
     */
    readonly maxFrameRate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#max_height ElastictranscoderPreset#max_height}.
     *
     * @stability stable
     */
    readonly maxHeight?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#max_width ElastictranscoderPreset#max_width}.
     *
     * @stability stable
     */
    readonly maxWidth?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#padding_policy ElastictranscoderPreset#padding_policy}.
     *
     * @stability stable
     */
    readonly paddingPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#resolution ElastictranscoderPreset#resolution}.
     *
     * @stability stable
     */
    readonly resolution?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#sizing_policy ElastictranscoderPreset#sizing_policy}.
     *
     * @stability stable
     */
    readonly sizingPolicy?: string;
}
/**
 * @stability stable
 */
export interface ElastictranscoderPresetVideoWatermarks {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#horizontal_align ElastictranscoderPreset#horizontal_align}.
     *
     * @stability stable
     */
    readonly horizontalAlign?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#horizontal_offset ElastictranscoderPreset#horizontal_offset}.
     *
     * @stability stable
     */
    readonly horizontalOffset?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#id ElastictranscoderPreset#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#max_height ElastictranscoderPreset#max_height}.
     *
     * @stability stable
     */
    readonly maxHeight?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#max_width ElastictranscoderPreset#max_width}.
     *
     * @stability stable
     */
    readonly maxWidth?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#opacity ElastictranscoderPreset#opacity}.
     *
     * @stability stable
     */
    readonly opacity?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#sizing_policy ElastictranscoderPreset#sizing_policy}.
     *
     * @stability stable
     */
    readonly sizingPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#target ElastictranscoderPreset#target}.
     *
     * @stability stable
     */
    readonly target?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#vertical_align ElastictranscoderPreset#vertical_align}.
     *
     * @stability stable
     */
    readonly verticalAlign?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html#vertical_offset ElastictranscoderPreset#vertical_offset}.
     *
     * @stability stable
     */
    readonly verticalOffset?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html aws_elastictranscoder_preset}.
 *
 * @stability stable
 */
export declare class ElastictranscoderPreset extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/elastictranscoder_preset.html aws_elastictranscoder_preset} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ElastictranscoderPresetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _container;
    /**
     * @stability stable
     */
    get container(): string;
    /**
     * @stability stable
     */
    set container(value: string);
    /**
     * @stability stable
     */
    get containerInput(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _type?;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    resetType(): void;
    /**
     * @stability stable
     */
    get typeInput(): string | undefined;
    private _videoCodecOptions?;
    /**
     * @stability stable
     */
    get videoCodecOptions(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set videoCodecOptions(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetVideoCodecOptions(): void;
    /**
     * @stability stable
     */
    get videoCodecOptionsInput(): {
        [key: string]: string;
    } | undefined;
    private _audio?;
    /**
     * @stability stable
     */
    get audio(): ElastictranscoderPresetAudio[];
    /**
     * @stability stable
     */
    set audio(value: ElastictranscoderPresetAudio[]);
    /**
     * @stability stable
     */
    resetAudio(): void;
    /**
     * @stability stable
     */
    get audioInput(): ElastictranscoderPresetAudio[] | undefined;
    private _audioCodecOptions?;
    /**
     * @stability stable
     */
    get audioCodecOptions(): ElastictranscoderPresetAudioCodecOptions[];
    /**
     * @stability stable
     */
    set audioCodecOptions(value: ElastictranscoderPresetAudioCodecOptions[]);
    /**
     * @stability stable
     */
    resetAudioCodecOptions(): void;
    /**
     * @stability stable
     */
    get audioCodecOptionsInput(): ElastictranscoderPresetAudioCodecOptions[] | undefined;
    private _thumbnails?;
    /**
     * @stability stable
     */
    get thumbnails(): ElastictranscoderPresetThumbnails[];
    /**
     * @stability stable
     */
    set thumbnails(value: ElastictranscoderPresetThumbnails[]);
    /**
     * @stability stable
     */
    resetThumbnails(): void;
    /**
     * @stability stable
     */
    get thumbnailsInput(): ElastictranscoderPresetThumbnails[] | undefined;
    private _video?;
    /**
     * @stability stable
     */
    get video(): ElastictranscoderPresetVideo[];
    /**
     * @stability stable
     */
    set video(value: ElastictranscoderPresetVideo[]);
    /**
     * @stability stable
     */
    resetVideo(): void;
    /**
     * @stability stable
     */
    get videoInput(): ElastictranscoderPresetVideo[] | undefined;
    private _videoWatermarks?;
    /**
     * @stability stable
     */
    get videoWatermarks(): ElastictranscoderPresetVideoWatermarks[];
    /**
     * @stability stable
     */
    set videoWatermarks(value: ElastictranscoderPresetVideoWatermarks[]);
    /**
     * @stability stable
     */
    resetVideoWatermarks(): void;
    /**
     * @stability stable
     */
    get videoWatermarksInput(): ElastictranscoderPresetVideoWatermarks[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
