import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IamAccountPasswordPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iam_account_password_policy.html#allow_users_to_change_password IamAccountPasswordPolicy#allow_users_to_change_password}.
     *
     * @stability stable
     */
    readonly allowUsersToChangePassword?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iam_account_password_policy.html#hard_expiry IamAccountPasswordPolicy#hard_expiry}.
     *
     * @stability stable
     */
    readonly hardExpiry?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iam_account_password_policy.html#max_password_age IamAccountPasswordPolicy#max_password_age}.
     *
     * @stability stable
     */
    readonly maxPasswordAge?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iam_account_password_policy.html#minimum_password_length IamAccountPasswordPolicy#minimum_password_length}.
     *
     * @stability stable
     */
    readonly minimumPasswordLength?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iam_account_password_policy.html#password_reuse_prevention IamAccountPasswordPolicy#password_reuse_prevention}.
     *
     * @stability stable
     */
    readonly passwordReusePrevention?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iam_account_password_policy.html#require_lowercase_characters IamAccountPasswordPolicy#require_lowercase_characters}.
     *
     * @stability stable
     */
    readonly requireLowercaseCharacters?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iam_account_password_policy.html#require_numbers IamAccountPasswordPolicy#require_numbers}.
     *
     * @stability stable
     */
    readonly requireNumbers?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iam_account_password_policy.html#require_symbols IamAccountPasswordPolicy#require_symbols}.
     *
     * @stability stable
     */
    readonly requireSymbols?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iam_account_password_policy.html#require_uppercase_characters IamAccountPasswordPolicy#require_uppercase_characters}.
     *
     * @stability stable
     */
    readonly requireUppercaseCharacters?: boolean;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/iam_account_password_policy.html aws_iam_account_password_policy}.
 *
 * @stability stable
 */
export declare class IamAccountPasswordPolicy extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/iam_account_password_policy.html aws_iam_account_password_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: IamAccountPasswordPolicyConfig);
    private _allowUsersToChangePassword?;
    /**
     * @stability stable
     */
    get allowUsersToChangePassword(): boolean;
    /**
     * @stability stable
     */
    set allowUsersToChangePassword(value: boolean);
    /**
     * @stability stable
     */
    resetAllowUsersToChangePassword(): void;
    /**
     * @stability stable
     */
    get allowUsersToChangePasswordInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get expirePasswords(): boolean;
    private _hardExpiry?;
    /**
     * @stability stable
     */
    get hardExpiry(): boolean;
    /**
     * @stability stable
     */
    set hardExpiry(value: boolean);
    /**
     * @stability stable
     */
    resetHardExpiry(): void;
    /**
     * @stability stable
     */
    get hardExpiryInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _maxPasswordAge?;
    /**
     * @stability stable
     */
    get maxPasswordAge(): number;
    /**
     * @stability stable
     */
    set maxPasswordAge(value: number);
    /**
     * @stability stable
     */
    resetMaxPasswordAge(): void;
    /**
     * @stability stable
     */
    get maxPasswordAgeInput(): number | undefined;
    private _minimumPasswordLength?;
    /**
     * @stability stable
     */
    get minimumPasswordLength(): number;
    /**
     * @stability stable
     */
    set minimumPasswordLength(value: number);
    /**
     * @stability stable
     */
    resetMinimumPasswordLength(): void;
    /**
     * @stability stable
     */
    get minimumPasswordLengthInput(): number | undefined;
    private _passwordReusePrevention?;
    /**
     * @stability stable
     */
    get passwordReusePrevention(): number;
    /**
     * @stability stable
     */
    set passwordReusePrevention(value: number);
    /**
     * @stability stable
     */
    resetPasswordReusePrevention(): void;
    /**
     * @stability stable
     */
    get passwordReusePreventionInput(): number | undefined;
    private _requireLowercaseCharacters?;
    /**
     * @stability stable
     */
    get requireLowercaseCharacters(): boolean;
    /**
     * @stability stable
     */
    set requireLowercaseCharacters(value: boolean);
    /**
     * @stability stable
     */
    resetRequireLowercaseCharacters(): void;
    /**
     * @stability stable
     */
    get requireLowercaseCharactersInput(): boolean | undefined;
    private _requireNumbers?;
    /**
     * @stability stable
     */
    get requireNumbers(): boolean;
    /**
     * @stability stable
     */
    set requireNumbers(value: boolean);
    /**
     * @stability stable
     */
    resetRequireNumbers(): void;
    /**
     * @stability stable
     */
    get requireNumbersInput(): boolean | undefined;
    private _requireSymbols?;
    /**
     * @stability stable
     */
    get requireSymbols(): boolean;
    /**
     * @stability stable
     */
    set requireSymbols(value: boolean);
    /**
     * @stability stable
     */
    resetRequireSymbols(): void;
    /**
     * @stability stable
     */
    get requireSymbolsInput(): boolean | undefined;
    private _requireUppercaseCharacters?;
    /**
     * @stability stable
     */
    get requireUppercaseCharacters(): boolean;
    /**
     * @stability stable
     */
    set requireUppercaseCharacters(value: boolean);
    /**
     * @stability stable
     */
    resetRequireUppercaseCharacters(): void;
    /**
     * @stability stable
     */
    get requireUppercaseCharactersInput(): boolean | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
