import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LaunchTemplateConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#default_version LaunchTemplate#default_version}.
     *
     * @stability stable
     */
    readonly defaultVersion?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#description LaunchTemplate#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#disable_api_termination LaunchTemplate#disable_api_termination}.
     *
     * @stability stable
     */
    readonly disableApiTermination?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#ebs_optimized LaunchTemplate#ebs_optimized}.
     *
     * @stability stable
     */
    readonly ebsOptimized?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#image_id LaunchTemplate#image_id}.
     *
     * @stability stable
     */
    readonly imageId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#instance_initiated_shutdown_behavior LaunchTemplate#instance_initiated_shutdown_behavior}.
     *
     * @stability stable
     */
    readonly instanceInitiatedShutdownBehavior?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#instance_type LaunchTemplate#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#kernel_id LaunchTemplate#kernel_id}.
     *
     * @stability stable
     */
    readonly kernelId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#key_name LaunchTemplate#key_name}.
     *
     * @stability stable
     */
    readonly keyName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#name LaunchTemplate#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#name_prefix LaunchTemplate#name_prefix}.
     *
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#ram_disk_id LaunchTemplate#ram_disk_id}.
     *
     * @stability stable
     */
    readonly ramDiskId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#security_group_names LaunchTemplate#security_group_names}.
     *
     * @stability stable
     */
    readonly securityGroupNames?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#tags LaunchTemplate#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#tags_all LaunchTemplate#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#update_default_version LaunchTemplate#update_default_version}.
     *
     * @stability stable
     */
    readonly updateDefaultVersion?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#user_data LaunchTemplate#user_data}.
     *
     * @stability stable
     */
    readonly userData?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#vpc_security_group_ids LaunchTemplate#vpc_security_group_ids}.
     *
     * @stability stable
     */
    readonly vpcSecurityGroupIds?: string[];
    /**
     * block_device_mappings block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#block_device_mappings LaunchTemplate#block_device_mappings}
     *
     * @stability stable
     */
    readonly blockDeviceMappings?: LaunchTemplateBlockDeviceMappings[];
    /**
     * capacity_reservation_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#capacity_reservation_specification LaunchTemplate#capacity_reservation_specification}
     *
     * @stability stable
     */
    readonly capacityReservationSpecification?: LaunchTemplateCapacityReservationSpecification[];
    /**
     * cpu_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#cpu_options LaunchTemplate#cpu_options}
     *
     * @stability stable
     */
    readonly cpuOptions?: LaunchTemplateCpuOptions[];
    /**
     * credit_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#credit_specification LaunchTemplate#credit_specification}
     *
     * @stability stable
     */
    readonly creditSpecification?: LaunchTemplateCreditSpecification[];
    /**
     * elastic_gpu_specifications block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#elastic_gpu_specifications LaunchTemplate#elastic_gpu_specifications}
     *
     * @stability stable
     */
    readonly elasticGpuSpecifications?: LaunchTemplateElasticGpuSpecifications[];
    /**
     * elastic_inference_accelerator block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#elastic_inference_accelerator LaunchTemplate#elastic_inference_accelerator}
     *
     * @stability stable
     */
    readonly elasticInferenceAccelerator?: LaunchTemplateElasticInferenceAccelerator[];
    /**
     * enclave_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#enclave_options LaunchTemplate#enclave_options}
     *
     * @stability stable
     */
    readonly enclaveOptions?: LaunchTemplateEnclaveOptions[];
    /**
     * hibernation_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#hibernation_options LaunchTemplate#hibernation_options}
     *
     * @stability stable
     */
    readonly hibernationOptions?: LaunchTemplateHibernationOptions[];
    /**
     * iam_instance_profile block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#iam_instance_profile LaunchTemplate#iam_instance_profile}
     *
     * @stability stable
     */
    readonly iamInstanceProfile?: LaunchTemplateIamInstanceProfile[];
    /**
     * instance_market_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#instance_market_options LaunchTemplate#instance_market_options}
     *
     * @stability stable
     */
    readonly instanceMarketOptions?: LaunchTemplateInstanceMarketOptions[];
    /**
     * license_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#license_specification LaunchTemplate#license_specification}
     *
     * @stability stable
     */
    readonly licenseSpecification?: LaunchTemplateLicenseSpecification[];
    /**
     * metadata_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#metadata_options LaunchTemplate#metadata_options}
     *
     * @stability stable
     */
    readonly metadataOptions?: LaunchTemplateMetadataOptions[];
    /**
     * monitoring block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#monitoring LaunchTemplate#monitoring}
     *
     * @stability stable
     */
    readonly monitoring?: LaunchTemplateMonitoring[];
    /**
     * network_interfaces block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#network_interfaces LaunchTemplate#network_interfaces}
     *
     * @stability stable
     */
    readonly networkInterfaces?: LaunchTemplateNetworkInterfaces[];
    /**
     * placement block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#placement LaunchTemplate#placement}
     *
     * @stability stable
     */
    readonly placement?: LaunchTemplatePlacement[];
    /**
     * tag_specifications block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#tag_specifications LaunchTemplate#tag_specifications}
     *
     * @stability stable
     */
    readonly tagSpecifications?: LaunchTemplateTagSpecifications[];
}
/**
 * @stability stable
 */
export interface LaunchTemplateBlockDeviceMappingsEbs {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#delete_on_termination LaunchTemplate#delete_on_termination}.
     *
     * @stability stable
     */
    readonly deleteOnTermination?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#encrypted LaunchTemplate#encrypted}.
     *
     * @stability stable
     */
    readonly encrypted?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#iops LaunchTemplate#iops}.
     *
     * @stability stable
     */
    readonly iops?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#kms_key_id LaunchTemplate#kms_key_id}.
     *
     * @stability stable
     */
    readonly kmsKeyId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#snapshot_id LaunchTemplate#snapshot_id}.
     *
     * @stability stable
     */
    readonly snapshotId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#throughput LaunchTemplate#throughput}.
     *
     * @stability stable
     */
    readonly throughput?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#volume_size LaunchTemplate#volume_size}.
     *
     * @stability stable
     */
    readonly volumeSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#volume_type LaunchTemplate#volume_type}.
     *
     * @stability stable
     */
    readonly volumeType?: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateBlockDeviceMappings {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#device_name LaunchTemplate#device_name}.
     *
     * @stability stable
     */
    readonly deviceName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#no_device LaunchTemplate#no_device}.
     *
     * @stability stable
     */
    readonly noDevice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#virtual_name LaunchTemplate#virtual_name}.
     *
     * @stability stable
     */
    readonly virtualName?: string;
    /**
     * ebs block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#ebs LaunchTemplate#ebs}
     *
     * @stability stable
     */
    readonly ebs?: LaunchTemplateBlockDeviceMappingsEbs[];
}
/**
 * @stability stable
 */
export interface LaunchTemplateCapacityReservationSpecificationCapacityReservationTarget {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#capacity_reservation_id LaunchTemplate#capacity_reservation_id}.
     *
     * @stability stable
     */
    readonly capacityReservationId?: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateCapacityReservationSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#capacity_reservation_preference LaunchTemplate#capacity_reservation_preference}.
     *
     * @stability stable
     */
    readonly capacityReservationPreference?: string;
    /**
     * capacity_reservation_target block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#capacity_reservation_target LaunchTemplate#capacity_reservation_target}
     *
     * @stability stable
     */
    readonly capacityReservationTarget?: LaunchTemplateCapacityReservationSpecificationCapacityReservationTarget[];
}
/**
 * @stability stable
 */
export interface LaunchTemplateCpuOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#core_count LaunchTemplate#core_count}.
     *
     * @stability stable
     */
    readonly coreCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#threads_per_core LaunchTemplate#threads_per_core}.
     *
     * @stability stable
     */
    readonly threadsPerCore?: number;
}
/**
 * @stability stable
 */
export interface LaunchTemplateCreditSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#cpu_credits LaunchTemplate#cpu_credits}.
     *
     * @stability stable
     */
    readonly cpuCredits?: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateElasticGpuSpecifications {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#type LaunchTemplate#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateElasticInferenceAccelerator {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#type LaunchTemplate#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateEnclaveOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#enabled LaunchTemplate#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean;
}
/**
 * @stability stable
 */
export interface LaunchTemplateHibernationOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#configured LaunchTemplate#configured}.
     *
     * @stability stable
     */
    readonly configured: boolean;
}
/**
 * @stability stable
 */
export interface LaunchTemplateIamInstanceProfile {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#arn LaunchTemplate#arn}.
     *
     * @stability stable
     */
    readonly arn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#name LaunchTemplate#name}.
     *
     * @stability stable
     */
    readonly name?: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateInstanceMarketOptionsSpotOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#block_duration_minutes LaunchTemplate#block_duration_minutes}.
     *
     * @stability stable
     */
    readonly blockDurationMinutes?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#instance_interruption_behavior LaunchTemplate#instance_interruption_behavior}.
     *
     * @stability stable
     */
    readonly instanceInterruptionBehavior?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#max_price LaunchTemplate#max_price}.
     *
     * @stability stable
     */
    readonly maxPrice?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#spot_instance_type LaunchTemplate#spot_instance_type}.
     *
     * @stability stable
     */
    readonly spotInstanceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#valid_until LaunchTemplate#valid_until}.
     *
     * @stability stable
     */
    readonly validUntil?: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateInstanceMarketOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#market_type LaunchTemplate#market_type}.
     *
     * @stability stable
     */
    readonly marketType?: string;
    /**
     * spot_options block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#spot_options LaunchTemplate#spot_options}
     *
     * @stability stable
     */
    readonly spotOptions?: LaunchTemplateInstanceMarketOptionsSpotOptions[];
}
/**
 * @stability stable
 */
export interface LaunchTemplateLicenseSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#license_configuration_arn LaunchTemplate#license_configuration_arn}.
     *
     * @stability stable
     */
    readonly licenseConfigurationArn: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateMetadataOptions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#http_endpoint LaunchTemplate#http_endpoint}.
     *
     * @stability stable
     */
    readonly httpEndpoint?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#http_put_response_hop_limit LaunchTemplate#http_put_response_hop_limit}.
     *
     * @stability stable
     */
    readonly httpPutResponseHopLimit?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#http_tokens LaunchTemplate#http_tokens}.
     *
     * @stability stable
     */
    readonly httpTokens?: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateMonitoring {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#enabled LaunchTemplate#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean;
}
/**
 * @stability stable
 */
export interface LaunchTemplateNetworkInterfaces {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#associate_carrier_ip_address LaunchTemplate#associate_carrier_ip_address}.
     *
     * @stability stable
     */
    readonly associateCarrierIpAddress?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#associate_public_ip_address LaunchTemplate#associate_public_ip_address}.
     *
     * @stability stable
     */
    readonly associatePublicIpAddress?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#delete_on_termination LaunchTemplate#delete_on_termination}.
     *
     * @stability stable
     */
    readonly deleteOnTermination?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#description LaunchTemplate#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#device_index LaunchTemplate#device_index}.
     *
     * @stability stable
     */
    readonly deviceIndex?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#interface_type LaunchTemplate#interface_type}.
     *
     * @stability stable
     */
    readonly interfaceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#ipv4_address_count LaunchTemplate#ipv4_address_count}.
     *
     * @stability stable
     */
    readonly ipv4AddressCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#ipv4_addresses LaunchTemplate#ipv4_addresses}.
     *
     * @stability stable
     */
    readonly ipv4Addresses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#ipv6_address_count LaunchTemplate#ipv6_address_count}.
     *
     * @stability stable
     */
    readonly ipv6AddressCount?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#ipv6_addresses LaunchTemplate#ipv6_addresses}.
     *
     * @stability stable
     */
    readonly ipv6Addresses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#network_interface_id LaunchTemplate#network_interface_id}.
     *
     * @stability stable
     */
    readonly networkInterfaceId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#private_ip_address LaunchTemplate#private_ip_address}.
     *
     * @stability stable
     */
    readonly privateIpAddress?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#security_groups LaunchTemplate#security_groups}.
     *
     * @stability stable
     */
    readonly securityGroups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#subnet_id LaunchTemplate#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId?: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplatePlacement {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#affinity LaunchTemplate#affinity}.
     *
     * @stability stable
     */
    readonly affinity?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#availability_zone LaunchTemplate#availability_zone}.
     *
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#group_name LaunchTemplate#group_name}.
     *
     * @stability stable
     */
    readonly groupName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#host_id LaunchTemplate#host_id}.
     *
     * @stability stable
     */
    readonly hostId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#host_resource_group_arn LaunchTemplate#host_resource_group_arn}.
     *
     * @stability stable
     */
    readonly hostResourceGroupArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#partition_number LaunchTemplate#partition_number}.
     *
     * @stability stable
     */
    readonly partitionNumber?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#spread_domain LaunchTemplate#spread_domain}.
     *
     * @stability stable
     */
    readonly spreadDomain?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#tenancy LaunchTemplate#tenancy}.
     *
     * @stability stable
     */
    readonly tenancy?: string;
}
/**
 * @stability stable
 */
export interface LaunchTemplateTagSpecifications {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#resource_type LaunchTemplate#resource_type}.
     *
     * @stability stable
     */
    readonly resourceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html#tags LaunchTemplate#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html aws_launch_template}.
 *
 * @stability stable
 */
export declare class LaunchTemplate extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/launch_template.html aws_launch_template} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: LaunchTemplateConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _defaultVersion?;
    /**
     * @stability stable
     */
    get defaultVersion(): number;
    /**
     * @stability stable
     */
    set defaultVersion(value: number);
    /**
     * @stability stable
     */
    resetDefaultVersion(): void;
    /**
     * @stability stable
     */
    get defaultVersionInput(): number | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _disableApiTermination?;
    /**
     * @stability stable
     */
    get disableApiTermination(): boolean;
    /**
     * @stability stable
     */
    set disableApiTermination(value: boolean);
    /**
     * @stability stable
     */
    resetDisableApiTermination(): void;
    /**
     * @stability stable
     */
    get disableApiTerminationInput(): boolean | undefined;
    private _ebsOptimized?;
    /**
     * @stability stable
     */
    get ebsOptimized(): string;
    /**
     * @stability stable
     */
    set ebsOptimized(value: string);
    /**
     * @stability stable
     */
    resetEbsOptimized(): void;
    /**
     * @stability stable
     */
    get ebsOptimizedInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _imageId?;
    /**
     * @stability stable
     */
    get imageId(): string;
    /**
     * @stability stable
     */
    set imageId(value: string);
    /**
     * @stability stable
     */
    resetImageId(): void;
    /**
     * @stability stable
     */
    get imageIdInput(): string | undefined;
    private _instanceInitiatedShutdownBehavior?;
    /**
     * @stability stable
     */
    get instanceInitiatedShutdownBehavior(): string;
    /**
     * @stability stable
     */
    set instanceInitiatedShutdownBehavior(value: string);
    /**
     * @stability stable
     */
    resetInstanceInitiatedShutdownBehavior(): void;
    /**
     * @stability stable
     */
    get instanceInitiatedShutdownBehaviorInput(): string | undefined;
    private _instanceType?;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    set instanceType(value: string);
    /**
     * @stability stable
     */
    resetInstanceType(): void;
    /**
     * @stability stable
     */
    get instanceTypeInput(): string | undefined;
    private _kernelId?;
    /**
     * @stability stable
     */
    get kernelId(): string;
    /**
     * @stability stable
     */
    set kernelId(value: string);
    /**
     * @stability stable
     */
    resetKernelId(): void;
    /**
     * @stability stable
     */
    get kernelIdInput(): string | undefined;
    private _keyName?;
    /**
     * @stability stable
     */
    get keyName(): string;
    /**
     * @stability stable
     */
    set keyName(value: string);
    /**
     * @stability stable
     */
    resetKeyName(): void;
    /**
     * @stability stable
     */
    get keyNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get latestVersion(): number;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _ramDiskId?;
    /**
     * @stability stable
     */
    get ramDiskId(): string;
    /**
     * @stability stable
     */
    set ramDiskId(value: string);
    /**
     * @stability stable
     */
    resetRamDiskId(): void;
    /**
     * @stability stable
     */
    get ramDiskIdInput(): string | undefined;
    private _securityGroupNames?;
    /**
     * @stability stable
     */
    get securityGroupNames(): string[];
    /**
     * @stability stable
     */
    set securityGroupNames(value: string[]);
    /**
     * @stability stable
     */
    resetSecurityGroupNames(): void;
    /**
     * @stability stable
     */
    get securityGroupNamesInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _updateDefaultVersion?;
    /**
     * @stability stable
     */
    get updateDefaultVersion(): boolean;
    /**
     * @stability stable
     */
    set updateDefaultVersion(value: boolean);
    /**
     * @stability stable
     */
    resetUpdateDefaultVersion(): void;
    /**
     * @stability stable
     */
    get updateDefaultVersionInput(): boolean | undefined;
    private _userData?;
    /**
     * @stability stable
     */
    get userData(): string;
    /**
     * @stability stable
     */
    set userData(value: string);
    /**
     * @stability stable
     */
    resetUserData(): void;
    /**
     * @stability stable
     */
    get userDataInput(): string | undefined;
    private _vpcSecurityGroupIds?;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIds(): string[];
    /**
     * @stability stable
     */
    set vpcSecurityGroupIds(value: string[]);
    /**
     * @stability stable
     */
    resetVpcSecurityGroupIds(): void;
    /**
     * @stability stable
     */
    get vpcSecurityGroupIdsInput(): string[] | undefined;
    private _blockDeviceMappings?;
    /**
     * @stability stable
     */
    get blockDeviceMappings(): LaunchTemplateBlockDeviceMappings[];
    /**
     * @stability stable
     */
    set blockDeviceMappings(value: LaunchTemplateBlockDeviceMappings[]);
    /**
     * @stability stable
     */
    resetBlockDeviceMappings(): void;
    /**
     * @stability stable
     */
    get blockDeviceMappingsInput(): LaunchTemplateBlockDeviceMappings[] | undefined;
    private _capacityReservationSpecification?;
    /**
     * @stability stable
     */
    get capacityReservationSpecification(): LaunchTemplateCapacityReservationSpecification[];
    /**
     * @stability stable
     */
    set capacityReservationSpecification(value: LaunchTemplateCapacityReservationSpecification[]);
    /**
     * @stability stable
     */
    resetCapacityReservationSpecification(): void;
    /**
     * @stability stable
     */
    get capacityReservationSpecificationInput(): LaunchTemplateCapacityReservationSpecification[] | undefined;
    private _cpuOptions?;
    /**
     * @stability stable
     */
    get cpuOptions(): LaunchTemplateCpuOptions[];
    /**
     * @stability stable
     */
    set cpuOptions(value: LaunchTemplateCpuOptions[]);
    /**
     * @stability stable
     */
    resetCpuOptions(): void;
    /**
     * @stability stable
     */
    get cpuOptionsInput(): LaunchTemplateCpuOptions[] | undefined;
    private _creditSpecification?;
    /**
     * @stability stable
     */
    get creditSpecification(): LaunchTemplateCreditSpecification[];
    /**
     * @stability stable
     */
    set creditSpecification(value: LaunchTemplateCreditSpecification[]);
    /**
     * @stability stable
     */
    resetCreditSpecification(): void;
    /**
     * @stability stable
     */
    get creditSpecificationInput(): LaunchTemplateCreditSpecification[] | undefined;
    private _elasticGpuSpecifications?;
    /**
     * @stability stable
     */
    get elasticGpuSpecifications(): LaunchTemplateElasticGpuSpecifications[];
    /**
     * @stability stable
     */
    set elasticGpuSpecifications(value: LaunchTemplateElasticGpuSpecifications[]);
    /**
     * @stability stable
     */
    resetElasticGpuSpecifications(): void;
    /**
     * @stability stable
     */
    get elasticGpuSpecificationsInput(): LaunchTemplateElasticGpuSpecifications[] | undefined;
    private _elasticInferenceAccelerator?;
    /**
     * @stability stable
     */
    get elasticInferenceAccelerator(): LaunchTemplateElasticInferenceAccelerator[];
    /**
     * @stability stable
     */
    set elasticInferenceAccelerator(value: LaunchTemplateElasticInferenceAccelerator[]);
    /**
     * @stability stable
     */
    resetElasticInferenceAccelerator(): void;
    /**
     * @stability stable
     */
    get elasticInferenceAcceleratorInput(): LaunchTemplateElasticInferenceAccelerator[] | undefined;
    private _enclaveOptions?;
    /**
     * @stability stable
     */
    get enclaveOptions(): LaunchTemplateEnclaveOptions[];
    /**
     * @stability stable
     */
    set enclaveOptions(value: LaunchTemplateEnclaveOptions[]);
    /**
     * @stability stable
     */
    resetEnclaveOptions(): void;
    /**
     * @stability stable
     */
    get enclaveOptionsInput(): LaunchTemplateEnclaveOptions[] | undefined;
    private _hibernationOptions?;
    /**
     * @stability stable
     */
    get hibernationOptions(): LaunchTemplateHibernationOptions[];
    /**
     * @stability stable
     */
    set hibernationOptions(value: LaunchTemplateHibernationOptions[]);
    /**
     * @stability stable
     */
    resetHibernationOptions(): void;
    /**
     * @stability stable
     */
    get hibernationOptionsInput(): LaunchTemplateHibernationOptions[] | undefined;
    private _iamInstanceProfile?;
    /**
     * @stability stable
     */
    get iamInstanceProfile(): LaunchTemplateIamInstanceProfile[];
    /**
     * @stability stable
     */
    set iamInstanceProfile(value: LaunchTemplateIamInstanceProfile[]);
    /**
     * @stability stable
     */
    resetIamInstanceProfile(): void;
    /**
     * @stability stable
     */
    get iamInstanceProfileInput(): LaunchTemplateIamInstanceProfile[] | undefined;
    private _instanceMarketOptions?;
    /**
     * @stability stable
     */
    get instanceMarketOptions(): LaunchTemplateInstanceMarketOptions[];
    /**
     * @stability stable
     */
    set instanceMarketOptions(value: LaunchTemplateInstanceMarketOptions[]);
    /**
     * @stability stable
     */
    resetInstanceMarketOptions(): void;
    /**
     * @stability stable
     */
    get instanceMarketOptionsInput(): LaunchTemplateInstanceMarketOptions[] | undefined;
    private _licenseSpecification?;
    /**
     * @stability stable
     */
    get licenseSpecification(): LaunchTemplateLicenseSpecification[];
    /**
     * @stability stable
     */
    set licenseSpecification(value: LaunchTemplateLicenseSpecification[]);
    /**
     * @stability stable
     */
    resetLicenseSpecification(): void;
    /**
     * @stability stable
     */
    get licenseSpecificationInput(): LaunchTemplateLicenseSpecification[] | undefined;
    private _metadataOptions?;
    /**
     * @stability stable
     */
    get metadataOptions(): LaunchTemplateMetadataOptions[];
    /**
     * @stability stable
     */
    set metadataOptions(value: LaunchTemplateMetadataOptions[]);
    /**
     * @stability stable
     */
    resetMetadataOptions(): void;
    /**
     * @stability stable
     */
    get metadataOptionsInput(): LaunchTemplateMetadataOptions[] | undefined;
    private _monitoring?;
    /**
     * @stability stable
     */
    get monitoring(): LaunchTemplateMonitoring[];
    /**
     * @stability stable
     */
    set monitoring(value: LaunchTemplateMonitoring[]);
    /**
     * @stability stable
     */
    resetMonitoring(): void;
    /**
     * @stability stable
     */
    get monitoringInput(): LaunchTemplateMonitoring[] | undefined;
    private _networkInterfaces?;
    /**
     * @stability stable
     */
    get networkInterfaces(): LaunchTemplateNetworkInterfaces[];
    /**
     * @stability stable
     */
    set networkInterfaces(value: LaunchTemplateNetworkInterfaces[]);
    /**
     * @stability stable
     */
    resetNetworkInterfaces(): void;
    /**
     * @stability stable
     */
    get networkInterfacesInput(): LaunchTemplateNetworkInterfaces[] | undefined;
    private _placement?;
    /**
     * @stability stable
     */
    get placement(): LaunchTemplatePlacement[];
    /**
     * @stability stable
     */
    set placement(value: LaunchTemplatePlacement[]);
    /**
     * @stability stable
     */
    resetPlacement(): void;
    /**
     * @stability stable
     */
    get placementInput(): LaunchTemplatePlacement[] | undefined;
    private _tagSpecifications?;
    /**
     * @stability stable
     */
    get tagSpecifications(): LaunchTemplateTagSpecifications[];
    /**
     * @stability stable
     */
    set tagSpecifications(value: LaunchTemplateTagSpecifications[]);
    /**
     * @stability stable
     */
    resetTagSpecifications(): void;
    /**
     * @stability stable
     */
    get tagSpecificationsInput(): LaunchTemplateTagSpecifications[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
