import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface RdsGlobalClusterConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/rds_global_cluster.html#database_name RdsGlobalCluster#database_name}.
     *
     * @stability stable
     */
    readonly databaseName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/rds_global_cluster.html#deletion_protection RdsGlobalCluster#deletion_protection}.
     *
     * @stability stable
     */
    readonly deletionProtection?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/rds_global_cluster.html#engine RdsGlobalCluster#engine}.
     *
     * @stability stable
     */
    readonly engine?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/rds_global_cluster.html#engine_version RdsGlobalCluster#engine_version}.
     *
     * @stability stable
     */
    readonly engineVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/rds_global_cluster.html#force_destroy RdsGlobalCluster#force_destroy}.
     *
     * @stability stable
     */
    readonly forceDestroy?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/rds_global_cluster.html#global_cluster_identifier RdsGlobalCluster#global_cluster_identifier}.
     *
     * @stability stable
     */
    readonly globalClusterIdentifier: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/rds_global_cluster.html#source_db_cluster_identifier RdsGlobalCluster#source_db_cluster_identifier}.
     *
     * @stability stable
     */
    readonly sourceDbClusterIdentifier?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/rds_global_cluster.html#storage_encrypted RdsGlobalCluster#storage_encrypted}.
     *
     * @stability stable
     */
    readonly storageEncrypted?: boolean;
}
/**
 * @stability stable
 */
export declare class RdsGlobalClusterGlobalClusterMembers extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get dbClusterArn(): string;
    /**
     * @stability stable
     */
    get isWriter(): boolean;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/rds_global_cluster.html aws_rds_global_cluster}.
 *
 * @stability stable
 */
export declare class RdsGlobalCluster extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/rds_global_cluster.html aws_rds_global_cluster} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: RdsGlobalClusterConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _databaseName?;
    /**
     * @stability stable
     */
    get databaseName(): string;
    /**
     * @stability stable
     */
    set databaseName(value: string);
    /**
     * @stability stable
     */
    resetDatabaseName(): void;
    /**
     * @stability stable
     */
    get databaseNameInput(): string | undefined;
    private _deletionProtection?;
    /**
     * @stability stable
     */
    get deletionProtection(): boolean;
    /**
     * @stability stable
     */
    set deletionProtection(value: boolean);
    /**
     * @stability stable
     */
    resetDeletionProtection(): void;
    /**
     * @stability stable
     */
    get deletionProtectionInput(): boolean | undefined;
    private _engine?;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    set engine(value: string);
    /**
     * @stability stable
     */
    resetEngine(): void;
    /**
     * @stability stable
     */
    get engineInput(): string | undefined;
    private _engineVersion?;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    set engineVersion(value: string);
    /**
     * @stability stable
     */
    resetEngineVersion(): void;
    /**
     * @stability stable
     */
    get engineVersionInput(): string | undefined;
    private _forceDestroy?;
    /**
     * @stability stable
     */
    get forceDestroy(): boolean;
    /**
     * @stability stable
     */
    set forceDestroy(value: boolean);
    /**
     * @stability stable
     */
    resetForceDestroy(): void;
    /**
     * @stability stable
     */
    get forceDestroyInput(): boolean | undefined;
    private _globalClusterIdentifier;
    /**
     * @stability stable
     */
    get globalClusterIdentifier(): string;
    /**
     * @stability stable
     */
    set globalClusterIdentifier(value: string);
    /**
     * @stability stable
     */
    get globalClusterIdentifierInput(): string;
    /**
     * @stability stable
     */
    globalClusterMembers(index: string): RdsGlobalClusterGlobalClusterMembers;
    /**
     * @stability stable
     */
    get globalClusterResourceId(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _sourceDbClusterIdentifier?;
    /**
     * @stability stable
     */
    get sourceDbClusterIdentifier(): string;
    /**
     * @stability stable
     */
    set sourceDbClusterIdentifier(value: string);
    /**
     * @stability stable
     */
    resetSourceDbClusterIdentifier(): void;
    /**
     * @stability stable
     */
    get sourceDbClusterIdentifierInput(): string | undefined;
    private _storageEncrypted?;
    /**
     * @stability stable
     */
    get storageEncrypted(): boolean;
    /**
     * @stability stable
     */
    set storageEncrypted(value: boolean);
    /**
     * @stability stable
     */
    resetStorageEncrypted(): void;
    /**
     * @stability stable
     */
    get storageEncryptedInput(): boolean | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
