import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface VolumeAttachmentConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/volume_attachment.html#device_name VolumeAttachment#device_name}.
     *
     * @stability stable
     */
    readonly deviceName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/volume_attachment.html#force_detach VolumeAttachment#force_detach}.
     *
     * @stability stable
     */
    readonly forceDetach?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/volume_attachment.html#instance_id VolumeAttachment#instance_id}.
     *
     * @stability stable
     */
    readonly instanceId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/volume_attachment.html#skip_destroy VolumeAttachment#skip_destroy}.
     *
     * @stability stable
     */
    readonly skipDestroy?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/volume_attachment.html#volume_id VolumeAttachment#volume_id}.
     *
     * @stability stable
     */
    readonly volumeId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/volume_attachment.html aws_volume_attachment}.
 *
 * @stability stable
 */
export declare class VolumeAttachment extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/volume_attachment.html aws_volume_attachment} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: VolumeAttachmentConfig);
    private _deviceName;
    /**
     * @stability stable
     */
    get deviceName(): string;
    /**
     * @stability stable
     */
    set deviceName(value: string);
    /**
     * @stability stable
     */
    get deviceNameInput(): string;
    private _forceDetach?;
    /**
     * @stability stable
     */
    get forceDetach(): boolean;
    /**
     * @stability stable
     */
    set forceDetach(value: boolean);
    /**
     * @stability stable
     */
    resetForceDetach(): void;
    /**
     * @stability stable
     */
    get forceDetachInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _instanceId;
    /**
     * @stability stable
     */
    get instanceId(): string;
    /**
     * @stability stable
     */
    set instanceId(value: string);
    /**
     * @stability stable
     */
    get instanceIdInput(): string;
    private _skipDestroy?;
    /**
     * @stability stable
     */
    get skipDestroy(): boolean;
    /**
     * @stability stable
     */
    set skipDestroy(value: boolean);
    /**
     * @stability stable
     */
    resetSkipDestroy(): void;
    /**
     * @stability stable
     */
    get skipDestroyInput(): boolean | undefined;
    private _volumeId;
    /**
     * @stability stable
     */
    get volumeId(): string;
    /**
     * @stability stable
     */
    set volumeId(value: string);
    /**
     * @stability stable
     */
    get volumeIdInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
