import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface WorklinkFleetConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#audit_stream_arn WorklinkFleet#audit_stream_arn}.
     *
     * @stability stable
     */
    readonly auditStreamArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#device_ca_certificate WorklinkFleet#device_ca_certificate}.
     *
     * @stability stable
     */
    readonly deviceCaCertificate?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#display_name WorklinkFleet#display_name}.
     *
     * @stability stable
     */
    readonly displayName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#name WorklinkFleet#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#optimize_for_end_user_location WorklinkFleet#optimize_for_end_user_location}.
     *
     * @stability stable
     */
    readonly optimizeForEndUserLocation?: boolean;
    /**
     * identity_provider block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#identity_provider WorklinkFleet#identity_provider}
     *
     * @stability stable
     */
    readonly identityProvider?: WorklinkFleetIdentityProvider[];
    /**
     * network block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#network WorklinkFleet#network}
     *
     * @stability stable
     */
    readonly network?: WorklinkFleetNetwork[];
}
/**
 * @stability stable
 */
export interface WorklinkFleetIdentityProvider {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#saml_metadata WorklinkFleet#saml_metadata}.
     *
     * @stability stable
     */
    readonly samlMetadata: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#type WorklinkFleet#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * @stability stable
 */
export interface WorklinkFleetNetwork {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#security_group_ids WorklinkFleet#security_group_ids}.
     *
     * @stability stable
     */
    readonly securityGroupIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#subnet_ids WorklinkFleet#subnet_ids}.
     *
     * @stability stable
     */
    readonly subnetIds: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html#vpc_id WorklinkFleet#vpc_id}.
     *
     * @stability stable
     */
    readonly vpcId: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html aws_worklink_fleet}.
 *
 * @stability stable
 */
export declare class WorklinkFleet extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/worklink_fleet.html aws_worklink_fleet} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: WorklinkFleetConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _auditStreamArn?;
    /**
     * @stability stable
     */
    get auditStreamArn(): string;
    /**
     * @stability stable
     */
    set auditStreamArn(value: string);
    /**
     * @stability stable
     */
    resetAuditStreamArn(): void;
    /**
     * @stability stable
     */
    get auditStreamArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get companyCode(): string;
    /**
     * @stability stable
     */
    get createdTime(): string;
    private _deviceCaCertificate?;
    /**
     * @stability stable
     */
    get deviceCaCertificate(): string;
    /**
     * @stability stable
     */
    set deviceCaCertificate(value: string);
    /**
     * @stability stable
     */
    resetDeviceCaCertificate(): void;
    /**
     * @stability stable
     */
    get deviceCaCertificateInput(): string | undefined;
    private _displayName?;
    /**
     * @stability stable
     */
    get displayName(): string;
    /**
     * @stability stable
     */
    set displayName(value: string);
    /**
     * @stability stable
     */
    resetDisplayName(): void;
    /**
     * @stability stable
     */
    get displayNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get lastUpdatedTime(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _optimizeForEndUserLocation?;
    /**
     * @stability stable
     */
    get optimizeForEndUserLocation(): boolean;
    /**
     * @stability stable
     */
    set optimizeForEndUserLocation(value: boolean);
    /**
     * @stability stable
     */
    resetOptimizeForEndUserLocation(): void;
    /**
     * @stability stable
     */
    get optimizeForEndUserLocationInput(): boolean | undefined;
    private _identityProvider?;
    /**
     * @stability stable
     */
    get identityProvider(): WorklinkFleetIdentityProvider[];
    /**
     * @stability stable
     */
    set identityProvider(value: WorklinkFleetIdentityProvider[]);
    /**
     * @stability stable
     */
    resetIdentityProvider(): void;
    /**
     * @stability stable
     */
    get identityProviderInput(): WorklinkFleetIdentityProvider[] | undefined;
    private _network?;
    /**
     * @stability stable
     */
    get network(): WorklinkFleetNetwork[];
    /**
     * @stability stable
     */
    set network(value: WorklinkFleetNetwork[]);
    /**
     * @stability stable
     */
    resetNetwork(): void;
    /**
     * @stability stable
     */
    get networkInput(): WorklinkFleetNetwork[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
